/**
* article.js
* 书签正文布局
* wei.shi#shouqu.me
*/


//main 入口
$(function(){

	
	//分享到外部的页面直接打开图片
	if($('body').hasClass('origin')){
		//alert("origin")
		$("img").each(function(){
			if(this.hasAttribute("data-original")){
				this.src = $(this).attr("data-original");
			}
			
		});
	}
	
	//调整图片显示尺寸
	//objImage,image 对象
	function resizeImage(objImage){
		if($('body').attr('id') == 'nobar' || objImage.src.match(/shouqu.com/g) != null){
		 	return true;
		 }
		//排除页脚底部的图片
		if(objImage.id != "footer-line" ){
			//如果图像的设置宽度与屏幕宽度差小于某个数值，则进而判断图片是否满足放大要求
			
			/*
			//console.log(objImage.offsetWidth);
			var diff = window.screen.width - objImage.offsetWidth;
			var min = 14;//测试宽度差值，可实时调整
			var ratio = objImage.offsetWidth / window.screen.width;
			////console.log("图片/屏幕宽度比：" ,ratio);
			
			if(
				diff < min || 
				(window.screen.width < 414 && ratio > 0.4) || 
				(window.screen.width == 414 && ratio > 0.36) || 
				(window.screen.width > 414 && window.screen.width <= 768 && ratio > 0.6)
			){
			*/
				
				//判断图片的原始大小，是否满足放大的要求
				getImgSize(objImage,function(res,obj){

					//get device type and name
					var device = checkMobile();
					var iphone_type = checkIphone();

					
						
					//如果图像原始宽度与屏幕宽度差小于某个数值，则强制放大至与屏幕宽度相同
					var diff = window.screen.width - res.width;
					var min = 14;//测试宽度差值，可实时调整
					var ratio = res.width / window.screen.width;
					////console.log("图片/屏幕宽度比：" ,ratio);
					
					
					
					if(
						diff < min || 
						(window.screen.width < 414 && ratio > 0.4) || 
						(window.screen.width == 414 && ratio > 0.36) || 
						(window.screen.width > 414 && window.screen.width <= 768 && ratio > 0.6)
					){
						//console.log("extend");
						obj.style.width = window.screen.width + "px";
					}else{
						////console.log("not extend");
						//新浪微博小图标
						if(obj.src.match(/timeline_card_small_[a-z]+_default/g) != null ){
							//console.log("sinaweibo");
							obj.style.width = '1em';
							obj.style.position = 'relative';
							obj.style.left = '4px';
							obj.style.verticalAlign = 'bottom';
						}else{
							////console.log('should autocenter');
							$(obj).addClass('autocenter');
						}
						
					}
					
					

				});
				
				/*
			}else{
				//console.log("not extend");
				//新浪微博小图标
				if(objImage.src.match(/timeline_card_small_[a-z]+_default/g) != null ){
					//console.log("weibo small card");
					objImage.style.width = '1em';
					objImage.style.position = 'relative';
					objImage.style.left = '4px';
					objImage.style.verticalAlign = 'bottom';
				}else{
					//console.log('should autocenter');
					$(objImage).addClass('autocenter');
				}
			}
			*/
			
			
		}
		
		

	}
	
	//lazyload,在不执行占位图转换时，load函数不起作用，但因为仍有部分书签正文中有占位图片，仍要执行此插件
	$("img").lazyload({
		//effect : "fadeIn",
		
		appear : function(elements_left, settings) {
		  ////console.log("appear");
		  ////console.log(elements_left);
		  ////console.log(this, elements_left, settings);
		  
		},
		load : function(elements_left, settings) {
			////console.log("load");
			////console.log(elements_left);
			////console.log(this, elements_left, settings);
			
			this.removeAttribute("width");
			this.removeAttribute("height");

			$(this).css('max-width','');

			//调整图片尺寸
			resizeImage(this);
		}
		
	});
	
	
	
	//从最外层元素开始遍历，处理所有图片
	var container_div = document.getElementById("overlaydiv");
	if( container_div != null && $("body").attr("id") != "nobar" ){

		//对所有图片进行处理，如果图片原始尺寸大于屏幕宽度则将其宽度设置为屏幕宽度
		//如果图片原始宽度与屏幕宽度比例大于某个值，也将将其宽度设置为屏幕宽度
		//其他图片则维持原始尺寸
		var images = container_div.getElementsByTagName('img');
		for(var i = 0; i < images.length; i++){
			var img = images[i];
			resizeImage(img);
		}

	}



	//视频标签宽度为屏幕宽度
	//$("video").css({"width":document.documentElement.clientWidth});
	$('video').each(function(){
		//alert(this);
		$(this).css("width",document.documentElement.clientWidth);
		this.setAttribute("width",document.documentElement.clientWidth);
	});

	//给知乎作者去掉前面逗号，如果没有简介则让用户名垂直居中
	(function($){
		if (!String.prototype.trim) {
		  String.prototype.trim = function () {
			return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
		  };
		}
		var $bio = $(".bio").length > 0 ? $(".bio") : false,
			$auth = $(".author-link,.name");
		if( $bio ){
			var trim_str = $bio.html().trim();
			if( trim_str.substring(0,1).match(/\uFF0C/g)){
				$bio.html(	trim_str.substring( 1 )	);
			}
		}else{
			$auth.css({"line-height":"38px"});
		}
	})(jQuery);



	//去除图片列表外部的li标签前导样式
	$('li').each(function(){
		if($(this).find('img').length > 0){
			if($(this).parents('ul')){
				$(this).parents('ul').css('list-style-type','none')
			}else if($(this).parents('ol')){
				$(this).parents('ol').css('list-style-type','none')
			}

		}
	});



	//blockquote中含有图片则去除blockquote的样式
	$("blockquote").each(function(){
		if($(this).find('img').length != 0){
			$(this).addClass('img-blockquote');
		}
	});

	//删除新浪体育底部
	$("#wx_pic,.art_share_btn,.art_tjbtn").remove();

	//删除正文flash
	$("#innerdiv embed,#innerdiv object").remove();

	//强制第一个p段落的margin-top为0
	if($("#innerdiv").find('p').length){
		$("#innerdiv").find('p')[0].style.marginTop = 0;
	}

	//给表格增加属性
	$('table').each(function(){
		this.setAttribute('cellpadding', "0");
		this.border = "0";
		this.setAttribute("cellspacing","0");
	});



	//处理iframe
	$('iframe').each(function(){
		this.setAttribute('scrolling','auto');
		var width = 320;
		if(window.matchMedia(MediaQuery.iphone4).matches || window.matchMedia(MediaQuery.iphone5).matches){
			width = 292;
		}else if(window.matchMedia(MediaQuery.iphone6).matches){
			width = 347;
		}else if(window.matchMedia(MediaQuery.iphone6plus).matches){
			width = 386;
		}
		this.setAttribute('width',width);
	});
	
	

});


/////////////////////笔记处理逻辑/////////////////////
////只有需要用到笔记功能的页面才需要执行下面的逻辑，其他页面不用////
$(function(){

    //just for test
    //MarkUtil.setDataFormatVersion(2);

	//app中加载的页面实际上是app处理后的内容，并非线上的地址，所以其location.href属性不可能包含http://协议内容，可以以此来判断是否是app打开的页面
	//isOnline使用href属性中是否包含http字符串来确定是app打开还是在浏览器打开
	//在分享后页面中也需要执行删除空白节点的方法，那个放在cover中去做
	var isSharedArticle = $("body").hasClass("origin");
	var isAppArticle = window.location.href.match(/http/i) == null;
	var needFormatTextNode = isSharedArticle || isAppArticle;

	//设置长按处理参数
	var activeTagClsName = "." + MarkUtil.activeClassName; //高亮类
	var plainTagClsName = "." + MarkUtil.markSpanClassName; //普通文本类
	var commentTagClsName = "." + MarkUtil.commentClassName;//注释按钮
	var startTime = 0; //计时开始点
	var threshold = 700;//高亮长按时间阈值，单位毫秒，默认与出现系统菜单的时间差不多
	var plainThreshold = 500;
	var activeTimerInterval = 10;//高亮长按响应时间间隔，10毫秒
	var plainTimerInterval = 50;//普通长按响应时间间隔，10毫秒
	
	function fixAndroidOffset(ex){
		if(navigator.userAgent.match(/iPhone|iPad|iPod/i) == null && ex.name.match(/IndexSizeError/ig) != null){
							MarkUtil.getMarkNodeByIndex(0).remove();
							MarkUtil.getMarkNodeByIndex(0).remove();
							js_loadNoteData(window.noteData);
						}
	}

	if(needFormatTextNode){
		//清除空白节点
		ArticleUtil.removeBlankNode();

		//页面初始化时消除已选中选区
		clearSelection();

		//格式化文本节点
		//MarkUtil.formatTextNodes();
	}

	//分享页中的正文逻辑
	if(isSharedArticle){

		//高亮处理逻辑配置
		var SHOW_NOTE_HIGHLIGHT = true;
		var SHOW_NOTE_COMMENT = true;

		if(window.location.href.indexOf("shouqu.me") != 0 ){

			//请求高亮数据
			if(SHOW_NOTE_HIGHLIGHT){
				if(window.noteData.notes.length > 0){
					//如果做过笔记，除新版代码生成外都认为是旧代码生成的，即使库中dataVersion值为null
					if(noteData.dataVersion != 2){
						noteData.dataVersion = 1;
					}
					try{
						js_loadNoteData(window.noteData);
					}catch(ex){
						//console.log(ex.name + ":" + ex.message);
						//在android设备上出现了indexsizeerror错误，说明页面多了两个sqt，需要移出两个空节点
						//console.log(ex);
						// if(navigator.userAgent.match(/iPhone|iPad|iPod/i) == null && ex.name.match(/IndexSizeError/ig) != null){
							// MarkUtil.getMarkNodeByIndex(0).remove();
							// MarkUtil.getMarkNodeByIndex(0).remove();
							// js_loadNoteData(window.noteData);
						// }
					}
				}
			} 

			//根据配置隐藏注释
			if(!SHOW_NOTE_COMMENT){
				$(".comment-icon").hide();
			}else{

				//绑定注释按钮点击，弹出气泡层
				//气泡层要实现根据文字多少自动调整，文字少时高度小，文字多时高度大，但不应过大或过小，默认设置为1-5行，多出文字用滚动条
				$("body").on("touchend",function(e){

					e.stopPropagation();

					if($(e.target).hasClass("comment-icon") || $(e.target.parentElement).hasClass("comment-icon")){
						var note_id = $(e.target).attr("data-noteid") || $(e.target.parentElement).attr("data-noteid");
						var fixed_target = $(e.target).hasClass("comment-icon") ? e.target : e.target.parentElement;
						hideCommentPop();
						showCommentPop(fixed_target.offsetTop,fixed_target.offsetLeft,note_id);
					}

				});

				$("." + MarkUtil.markSpanClassName + ", ." + MarkUtil.activeClassName).on('touchend',hideCommentPop);

			}

		}

		//显示注释层
		function showCommentPop(top,left,noteID){

			if(!arguments.length == 3){
				console.log("无效的参数");
				return false;
			}
			try{
				var note = _.filter(window.noteData.notes,function(obj){
					return obj.noteID == noteID;
				});

				if(note.length == 1){
					var comment = note[0].comment[0];
					var comment_content = comment.commentContent;
					console.log("comment:",comment_content);

					var _width = document.documentElement.offsetWidth - 70;
					if( (document.body.scrollHeight - top) < (document.body.clientHeight / 3) ){
						console.log("pop alter");
						//top = top - 36;


						var $pop = $('<div class="pop" id="popComment" style="display:none;"><div class="pop-wrapper"><div class="pop-corner"></div><div class="pop-content">'+ comment_content +'</div></div></div>')
							.appendTo('body').css({maxWidth:_width,width:_width}).show();
						$pop.find(".pop-corner").css({left:left-6}).addClass("pop-corner-alter");
						console.log(top,$pop[0].clientHeight);
						var alter_top = top - $pop[0].clientHeight ;
						$pop.css({top:alter_top});
					}else{
						top = top + 36;
						var $pop = $('<div class="pop" id="popComment" style="display:none;"><div class="pop-wrapper"><div class="pop-corner"></div><div class="pop-content">'+ comment_content +'</div></div></div>')
							.appendTo('body').css({top:top ,maxWidth:_width,width:_width}).show();
						$pop.find(".pop-corner").css({left:left-6});
					}


				}else{
					console.log("数据长度错误");
				}

			}catch(ex){
				console.log(ex.name + ":" + ex.message);
			}

		}
		//隐藏注释内容层
		function hideCommentPop(){
			$(".pop").remove();
		}
	}

	//app中正文逻辑
	if(isAppArticle){

		//加载已有note数据
		if(window.currentNoteData){
			MarkUtil.loadMarkData(window.currentNoteData);
		}

		//普通文本长按
		$('body').delegate(activeTagClsName, "touchstart", event, activeTextLongPressHandler );
		$('body').delegate(activeTagClsName, "touchend", function(event){
			//阻止事件冒泡，防止重复触发
			event.stopPropagation();

			//长按时间过短则取消
			var now = _.now();
			var diff = now - startTime;
			if(diff < threshold){
				clearInterval(window.touchTimer);
			}

			//重新绑定
			$('body').delegate(activeTagClsName,"touchstart",event,activeTextLongPressHandler);
		});

		//高亮文本长按
		$('body').delegate(plainTagClsName, "touchstart", event, plainTextLongPressHandler );
		$('body').delegate(plainTagClsName, "touchend", function(event){
			//阻止事件冒泡，防止重复触发
			event.stopPropagation();

			//长按时间过短则取消
			var now = _.now();
			var diff = now - startTime;
			if(diff < threshold){
				clearInterval(window.touchTimer);
			}

			if(event.target.nodeName == "B" && event.target.offsetParent.className == MarkUtil.commentClassName || event.target.nodeName == "I" && event.target.className == MarkUtil.commentClassName){
				clearInterval(window.touchTimer);
			}

			//重新绑定
			$('body').delegate(plainTagClsName,"touchstart",event,plainTextLongPressHandler);
		});

		//注释按钮及子元素点击
		//！注：这里使用了touchend事件来作为触发条件
		$("body").delegate( (commentTagClsName + "," + commentTagClsName + " b"),"touchend",function(event){

			event.preventDefault();
			event.stopPropagation();
			
			var screenx = event.originalEvent.changedTouches[0].clientX;
			var screeny = event.originalEvent.changedTouches[0].clientY;
			//获取noteID
			var noteID = $(event.target).attr("data-noteid");
			if(typeof noteID == "undefined"){
				noteID = $(event.target).parent("." + MarkUtil.commentClassName).attr("data-noteid");
			}
			//此处可考虑js实现气泡层，但需要很多编码和逻辑控制
			try{
				if(typeof window.note != "undefined" && typeof window.note.native_displayCommentMenu != "undefined"){
					window.note.native_displayCommentMenu(screenx,screeny,noteID);;
				}else{
					native_displayCommentMenu(screenx,screeny,noteID);;
				}
			}catch(ex){
				console.log(ex.name + ":" + ex.message);
			}

			$('body').delegate(plainTagClsName, "touchstart", event, plainTextLongPressHandler );

		} );
	}


	//普通文本长按事件处理
	//注：当使用jQuery绑定事件时，event为jQuery事件对象，可以用event.originalEvent来获取系统原始的事件对象
	function plainTextLongPressHandler(event){

		if(event.target.nodeName == "B" && event.target.offsetParent.className == MarkUtil.commentClassName || event.target.nodeName == "I" && event.target.className == MarkUtil.commentClassName){
			console.log("plain but target is comment");
			$('body').undelegate(plainTagClsName,"touchstart");
		}else{

		//不取消默认事件，使高亮文本也可以用来滑动页面
		//event.preventDefault();
		event.stopPropagation();

		//用underscore now方法取触摸开始的时间
		startTime = _.now();

		//解绑touch事件，防止多次触发
		$('body').undelegate(plainTagClsName,"touchstart");

		//开启定时器，当定时器超过阈值时通知native弹出菜单，并恢复代理绑定
		window.touchTimer = window.setInterval(function(){

			var now = _.now();
			var diff = now - startTime;
			console.log( "plain text press hold on:" + diff + " miliseconds");
			if(diff > threshold){

				//清除计时器
				clearInterval(window.touchTimer);

				//取选区数据
				var selection = window.getSelection();
				if(selection.type.toLowerCase() == "range"){

					var anchorNode = selection.anchorNode;
					var focusNode = selection.focusNode;

					//确保起止节点都在文本节点内
					if(anchorNode.nodeType == document.TEXT_NODE && focusNode.nodeType == document.TEXT_NODE){

						//console.log("选中了文字节点");

						/*
						//方法一：利用range对象设置选区起止偏移量
						var range = document.createRange();
						range.setStart(anchorNode,0);
						//console.log(range);
						range.setEnd(anchorNode,anchorNode.nodeValue.length);

						console.log(range);
						selection.addRange(range);
						*/

						//方法二：利用selection.selectAllChildren,此方法为实验方法，不能确定浏览器是否实现
						selection.selectAllChildren(anchorNode.parentElement);

						//console.log(selection.toString());
						//console.log(selection)

					}else{
						console.log("没有选中任何文本");
						return false;
					}
				}

			}
		},plainTimerInterval);
		}
	}

	function activeTextLongPressHandler(event){

		//console.log(event);

		//不取消默认事件，使高亮文本也可以用来滑动页面
		event.stopPropagation();

		//拿到触摸开始的时间，使用了underscore的now方法
		startTime = _.now();

		//解绑touch事件，防止多次触发
		$('body').undelegate(activeTagClsName,"touchstart");

		//获取坐标
		var screenx = event.originalEvent.changedTouches[0].clientX;
		var screeny = event.originalEvent.changedTouches[0].clientY;
		var noteID = $(event.currentTarget).attr("data-noteid") + "";//强制转换为字符串

		//当计时超过时间阈值时通知native弹出菜单
		window.touchTimer = window.setInterval(function(){

			var now = _.now();
			var diff = now - startTime;
			console.log( "active text press hold on:" + (diff/1000).toFixed(2) + "seconds");

			if(diff > threshold){

				//清除计时器
				clearInterval(window.touchTimer);

				//测试时可注掉，线上必须开启
				//native_popMenushowWithLocation(screenx,screeny,noteID);


				console.log("long pressed,coordinates:",screenx,screeny);
				console.log("noteID:",noteID);
				console.log("execute pop native menu");
				
				//获取长按高亮部分的文字
				var $hnodes = $("span[data-noteid='"+ noteID +"']");
				var htext = "";
				$hnodes.each(function(idx,val){
					htext += val.innerText;
				});
				console.log(htext);

				try{
					if(typeof window.note != "undefined" && typeof window.note.native_popMenushowWithLocation != "undefined"){
						window.note.native_popMenushowWithLocation(screenx,screeny,noteID,htext);;
					}else{
						native_popMenushowWithLocation(screenx,screeny,noteID);;
					}
				}catch(exception){
					console.log(exception.name + ":" + exception.message);
				}

			}
		},activeTimerInterval);

	}

});
/////////////////////.笔记处理逻辑/////////////////////